<?php

/**
 * @version		$Id$
 * @package		ARTIO Booking
 * @subpackage  	elements
 * @copyright		Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author 			ARTIO s.r.o., http://www.artio.net
 * @license     	GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link        	http://www.artio.net Official website
 */

defined('_JEXEC') or die('Restricted access');

class JFormFieldTerm extends JFormField
{

	public $type = 'Term';
	/**
	 * @var JFormFieldCheckbox
	 */
	private $_checkbox;
	/**
	 * @var JFormFieldHidden
	 */
	private $_hidden;

	/**
	 * (non-PHPdoc)
	 * @see JFormField::getInput()
	 */
	protected function getInput()
	{
		JFormHelper::loadFieldClass('checkbox');
		$this->_checkbox = JFormHelper::loadFieldType('checkbox', true)->setForm($this->form);
		$this->_checkbox->setup($this->element, $this->value, $this->group);
		
		JFormHelper::loadFieldClass('hidden');
		$this->_hidden = JFormHelper::loadFieldType('hidden', true)->setForm($this->form);
		$element = clone $this->element;
		$element['id'] = uniqid();
		$this->_hidden->setup($element, 0, $this->group);
		
		$code = '<table>';
		$code .= '	<tr>';
		$code .= '		<td>' . $this->_hidden->__get('input') . $this->_checkbox->__get('input') . '</td>';
		$code .= '		<td style="width: 150px">' . parent::getLabel() . '</td>';
		$code .= '		<td><label>' . JHtml::link(JRoute::_($this->element['link']), JText::_($this->element['linktext'])) . '</label></td>';
		$code .= '	</tr>';
		$code .= '</table>';
		return $code;
	}
	
	/**
	 * (non-PHPdoc)
	 * @see JFormField::getLabel()
	 */
	protected function getLabel()
	{
		return '';
	} 
}