<?php

/**
 * Config model. Support for database operations.
 * 
 * @version		$Id$
 * @package		ARTIO Booking
 * @subpackage  models
 * @copyright	Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author 		ARTIO s.r.o., http://www.artio.net
 * @license     GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link        http://www.artio.net Official website
 */

defined('_JEXEC') or die('Restricted access');

// import needed Joomla! libraries
jimport('joomla.application.component.model');
// import needed JoomLIB helpers
AImporter::helper('model');
AImporter::helper('artio-update');
AImporter::model('admin');

class BookingModelConfig extends AModel
{

	/**
	 * Store component configuration into database.
	 * In Joomla 1.5.x is used table jos_components in Joomla 1.6.x table jos_extensions.
	 * In both is used column params.
	 * 
	 * @return boolean true/false if query success/unsuccess
	 */
    function store(&$data)
    {
    	// Save the rules
    	if (isset($data['params']) && isset($data['params']['rules'])) {
    		if(JFactory::getUser()->authorise('booking.configuration.manage', 'com_booking')) {
    			foreach ($data['params']['rules'] as $rule => $usergroups) { // filter empty value
    				foreach ($usergroups as $usergroup => $allowed)
    					if ($allowed === '') // inherited or not set
							unset($data['params']['rules'][$rule][$usergroup]);    						
    			}
	    		$rules	= new JAccessRules($data['params']['rules']);
	    		$asset	= JTable::getInstance('asset');
	    	
	    		if (!$asset->loadByName($data['option'])) {
	    			$root	= JTable::getInstance('asset');
	    			$root->loadByName('root.1');
	    			$asset->name = $data['option'];
	    			$asset->title = $data['option'];
	    			$asset->setLocation($root->id, 'last-child');
	    		}
	    		$asset->rules = (string) $rules;
	    	
	    		if (!$asset->check() || !$asset->store()) {
	    			$this->setError($asset->getError());
	    			return false;
	    		}
    		}
    	
    		// We don't need this anymore
    		unset($data['option']);
    		unset($data['params']['rules']);
    	}
    	
    	
        /*
        $registry = new JRegistry();
        $registry->loadArray($data['params']);
    	 if (ISJ16)
    		$this->_db->setQuery('UPDATE `#__extensions` SET `params` = ' . $this->_db->Quote($registry->toString()) . ' WHERE `element` = \'' . OPTION . '\'');
    	else
    		$this->_db->setQuery('UPDATE `#__components` SET `params` = ' . $this->_db->Quote($registry->toString()) . ' WHERE `option` = \'' . OPTION . '\' AND `parent` = 0');
    	*/

    	$data['params']['taxrates'] = array();
    	
    	if (!empty($data['taxratetitle']))
    		foreach ($data['taxratetitle'] as $i => $title)
    			$data['params']['taxrates'][$i] = array($title, $data['taxratevalue'][$i]);
    	
    	$data['params']['taxrates'] = serialize($data['params']['taxrates']);

    	AImporter::model('userconfig');
    	if(AUser::onlyOwner())
    	{
    		$customconfig = new BookingModelUserConfig();
    		$ret = $customconfig->store($data);
    	}
    	else
    	{
    	
	        $ret = true;
	       	if (array_key_exists('params', $data)) {
		        foreach ($data['params'] as $key => $value) {
		        	$this->_db->setQuery('INSERT INTO `#__booking_config` (`key`, `value`) VALUES (' . $this->_db->quote($key) . ', ' . $this->_db->Quote($value) . ') ON DUPLICATE KEY UPDATE `value` = ' . $this->_db->Quote($value));
		        	$ret &= $this->_db->query();
		        }
		        // update the Joomla uppdater link
		        if (array_key_exists('artioDownloadId', $data['params']))
		        	BookingUpdateHelper::setUpdateLink('ARTIO Booking Updates', $data['params']['artioDownloadId']);
	       	}
		    else {
		    	$ret = false;
		    	JError::raiseWarning(0, "Config values were not saved! (Array key 'params' is missing.)");
		    }
    	}
        return $ret;
    }

    /**
     * Set all Joomla Super administrators as Booking administrators.
     * 
     * @return void
     */
    function setAdmins()
    {
    	$model = new BookingModelAdmin();
        //$this->_db->setQuery('SELECT `id` FROM `#__users` WHERE `usertype` = \'' . JUSER_SUPER_ADMINISTRATOR . '\'');
    	$q = "SELECT m.`user_id` FROM `#__user_usergroup_map` as m LEFT JOIN `#__usergroups` as g ON m.group_id = g.id WHERE g.`title` = '" . JUSER_SUPER_ADMINISTRATOR . "'";
    	$this->_db->setQuery($q);
        $model->setAsAdmin($this->_db->loadAssocList('user_id','user_id'));
    }
}

?>