<?php

/**
 * Subject-prices edit form template
 * 
 * @version		$Id$
 * @package		ARTIO Booking
 * @subpackage  views
 * @copyright	Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author 		ARTIO s.r.o., http://www.artio.net
 * @license     GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link        http://www.artio.net Official website
 */

defined('_JEXEC') or die('Restricted access');

/* @var $this BookingViewSubject */

$config = &AFactory::getConfig();
/* @var $config BookingConfig */

$rtypes = $this->rtypes;
unset($rtypes[0]);

$checkThisDayInAllPrices = $this->escape(JText::_('CHECK_THIS_DAY_IN_ALL_PRICES'));
$checkAllDaysInThisPrice = $this->escape(JText::_('CHECK_ALL_DAYS_IN_THIS_PRICE'));
$checkAllDaysInAllPrices = $this->escape(JText::_('CHECK_ALL_DAYS_IN_ALL_PRICES'));

$weeks[] = JHtml::_('select.option', WEEK_EVERY, JText::_('EVERY_WEEKS'));
$weeks[] = JHtml::_('select.option', WEEK_EVEN, JText::_('ONLY_EVEN_WEEKS'));
$weeks[] = JHtml::_('select.option', WEEK_ODD, JText::_('ONLY_ODD_WEEKS'));

$deposittype[] = JHtml::_('select.option', DEPOSIT_TYPE_VALUE, $config->mainCurrency);
$deposittype[] = JHtml::_('select.option', DEPOSIT_TYPE_PERCENT, '%');

$canceltimesettings[] = JHtml::_('select.option', CANCEL_NONE, JText::_('DISABLED'));
$canceltimesettings[] = JHtml::_('select.option', CANCEL_IMMEDIATELY, JText::_('ONLINE_PAYMENT_ONLY'));
$canceltimesettings[] = JHtml::_('select.option', CANCEL_AFTER, JText::_('AFTER_RESERVATION'));
$canceltimesettings[] = JHtml::_('select.option', CANCEL_BEFORE, JText::_('BEFORE_BOOKING'));

$canceltime[] = JHtml::_('select.option', EXPIRE_FORMAT_HOUR, JText::_('HOURS'));
$canceltime[] = JHtml::_('select.option', EXPIRE_FORMAT_DAY, JText::_('DAYS'));

JHtml::script('administrator/components/com_booking/assets/colorpicker/jscolor.js');

?>	
<div class="width-100" id="prices">
	<input type="hidden" name="<?php echo PRICES_PREFIX . 'date_up[]'; ?>" value="" />
	<input type="hidden" name="<?php echo PRICES_PREFIX . 'date_down[]'; ?>" value="" />
	<input type="hidden" name="<?php echo PRICES_PREFIX . 'time_up[]'; ?>" value="" />
	<input type="hidden" name="<?php echo PRICES_PREFIX . 'time_down[]'; ?>" value="" />
	<fieldset class="adminform">
    	<legend class="hasTip" title="<?php echo $this->escape(JText::_('PRICES')) . '::' . $this->escape(JText::_('PRICES_TOP_INFO')); ?>">
    		<?php echo JText::_('PRICES'); ?>
    	</legend>
    	<?php if (count($this->rtypes) > 1) { ?>
	    	<div>
	    		<?php
	    			$bar = &JToolBar::getInstance('prices');
        			$bar->appendButton('ALink', 'new', 'Add', 'EditSubject.addPrice()');
        			$bar->appendButton('ALink', 'delete', 'Delete', 'EditSubject.removePrices()');
        			echo $bar->render();
	    		/*
	    		echo '<div class="btn-group pull-left">
							<button type="button" class="btn" title="' . JText::_('NEW') . '" onclick="EditSubject.addPrice(); return false;"><span class="icon-new"></span>New</button>
							<button type="button" class="btn" title="' . JText::_('DELETE') . '" onclick="EditSubject.removePrices(); return false;"><span class="icon-delete"></span>Delete</button>
						</div>';
				*/
	    		?>
				
				<div class="clr"></div>
    			<table class="template">
					<tr>
						<td colspan="2">
							<label class="inline hasTip" for="book_over_timeliness" title="<?php echo $this->escape(($title = JText::_('BOOK_OVER_TIMELINESS'))) . '::' . $this->escape(JText::_('BOOK_OVER_TIMELINESS_INFO')); ?>">
    							<input type="checkbox" class="inputCheckbox" name="book_over_timeliness" id="book_over_timeliness" value="1" <?php if ($this->subject->book_over_timeliness == 1) { ?>checked="checked"<?php } ?> />
    							<div class="checkboxLabel"><?php echo $title; ?></div>
    						</label>
    					</td>
    					<?php if ($config->usingPrices) { ?>
	    					<td rowspan="3">
	    						<h3 class="hasTip" title="<?php echo $this->escape(($title = JText::_('SINGLE_TIME_DISCOUNTS'))) . '::' . $this->escape(JText::_('SINGLE_TIME_DISCOUNTS_INFO')); ?>"><?php echo JText::_('SINGLE_TIME_DISCOUNTS'); ?></h3>
	    						<table style="width: 100%">
	    							<tr>
	    								<td width="50%">
	    									<label class="hasTip" for="single_deposit" title="<?php echo JText::_('UNIT_COUNTS'); ?>::<?php echo JText::_('TIME_UNIT_COUNTS_INFO'); ?>"><?php echo JText::_('UNIT_COUNTS'); ?></label>
	    									<br/>
	    									<textarea class="price" rows="1" cols="1" id="single_discount_unit" name="single_discount_unit"><?php echo $this->subject->single_discount_unit; ?></textarea>
	    								</td>
	    								<td width="50%">
	    									<label class="hasTip" for="single_deposit"  title="<?php echo JText::_('UNIT_DISCOUNT'); ?>::<?php echo JText::_('TIME_UNIT_DISCOUNT_INFO'); ?>"><?php echo JText::_('UNIT_DISCOUNT'); ?></label>
	    									<br/>
	    									<textarea class="price" rows="1" cols="1" id="single_discount" name="single_discount"><?php echo $this->subject->single_discount; ?></textarea>
	    								</td>
	    							</tr>
	    						</table>
	    					</td>
    					<?php } ?>
    				</tr>
    				<?php if ($config->usingPrices == PRICES_WITH_DEPOSIT) { ?>
	    				<tr>
	    					<td>
	    						<label class="hasTip" for="single_deposit" title="<?php echo $this->escape(($title = JText::_('SINGLE_DEPOSIT'))) . '::' . $this->escape(JText::_('SINGLE_DEPOSIT_INFO')); ?>"><?php echo $title; ?></label>
	    					</td>
	    					<td>
	    						<input class="number" type="text" name="single_deposit" id="single_deposit" value="<?php echo $this->escape($this->subject->single_deposit); ?>" onkeyup="ACommon.toFloat(this)" style="margin: 0px 0px 0px 5px;" />
	 							<?php echo JHtml::_('select.genericlist', $deposittype, 'single_deposit_type', 'style="margin: 0"', 'value', 'text', $this->subject->single_deposit_type); ?>
	 							<div class="clr" style="padding: 5px"></div>   						
	    						<input type="hidden" name="single_deposit_include_supplements" value="<?php echo $this->subject->single_deposit_include_supplements; ?>" />
	    						<label class="inline hasTip" title="<?php echo JText::_('INCLUDE_SUPPLEMENTS'); ?>::<?php echo JText::_('INCLUDE_SUPPLEMENTS_INFO'); ?>">
									<input type="checkbox" class="inputCheckbox" id="single_deposit_include_supplements" name="another_fake[]" <?php if ($this->subject->single_deposit_include_supplements) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" style="margin: 4px 0px 0px;" />
									<div class="checkboxLabel"><?php echo JText::_('INCLUDE_SUPPLEMENTS'); ?></div>
								</label>
	    					</td>
	    				</tr>
    				<?php } 
    				if ($config->usingPrices) { ?>
	    				<tr>
	    					<td>
	    						<label class="hasTip" for="tax" title="<?php echo $this->escape(($title = JText::_('TAX_RATE'))) . '::' . $this->escape(JText::_('TAX_INFO')); ?>"><?php echo $title; ?></label>
	    					</td>
	    					<td>
	    						<?php
	    							$options = array(JHtml::_('select.option', '-1', JText::_('NO_TAX'))); 
	    							foreach ($config->taxRates as $id => $taxrate)
										$options[] = JHtml::_('select.option', $id, $taxrate[0]);
	    							echo JHtml::_('select.genericlist', $options, 'tax_rate_id', '', 'value', 'text', $this->subject->tax_rate_id);
	    						?>
	    					</td>
	    				</tr>
    				<?php } ?>
    			</table>
    			<div class="clr"></div>
				<table class="template">
					<thead>
						<tr>
							<th rowspan="2" valign="top">&nbsp;</th>
							<th rowspan="2" valign="top" width="20"><h3><?php echo JText::_('ID'); ?></h3></th>
							<?php if ($config->usingPrices) { ?>
								<th rowspan="2" valign="top" width="50"><h3><?php echo JText::_('VALUE'); ?><span class="star"> *</span></h3></th>
							<?php }
							if ($config->usingPrices == PRICES_WITH_DEPOSIT) { ?>
								<th colspan="3" align="center" valign="top"><h3><?php echo JText::_('DEPOSIT'); ?></h3></th>
							<?php } 
							if ($config->usingPrices) { ?>
								<th colspan="2" align="center" valign="top" class="hasTip" title="<?php echo JText::_('TIME_DISCOUNTS'); ?>::<?php echo JText::_('TIME_DISCOUNTS_INFO'); ?>"><h3><?php echo JText::_('TIME_DISCOUNTS'); ?></h3></th>
							<?php } ?>
							<th colspan="2" valign="top" class="show_occupancy"><h3><?php echo JText::_('OCCUPANCY'); ?></h3></th>
							<th rowspan="2" valign="top"><h3><?php echo JText::_('RESERVATION_TYPE'); ?><span class="star"> *</span></h3></th>
							<th colspan="2" align="center" valign="top" width="450">
								<h3>
									<?php echo JText::_('DATE_RANGE'); ?>
									<br/>
									<?php echo JText::_('TIME_RANGE_ONLY_FOR_HOURLY_TYPE'); ?>
								</h3>
							</th>
						</tr>
						<tr>
							<?php if ($config->usingPrices == PRICES_WITH_DEPOSIT) { ?>
								<th rowspan="2" valign="top" class="hasTip" title="<?php echo JText::_('VALUE'); ?>::<?php echo JText::_('VALUE'); ?>"><h3><?php echo JText::_('VALUE'); ?></h3></th>
								<th rowspan="2" valign="top" class="hasTip" title="<?php echo JText::_('RESERVATION_EXPIRATION'); ?>::<?php echo JText::_('RESERVATION_EXPIRATION_INFO'); ?>"><h3><?php echo JText::_('RESERVATION_EXPIRATION'); ?></h3></th>							
								<th rowspan="2" valign="top"><h3><?php echo JText::_('DEPOSIT_SETTINGS'); ?></h3></th>
							<?php } 
							if ($config->usingPrices) { ?>							
								<th valign="top" class="hasTip" title="<?php echo JText::_('UNIT_COUNTS_BOOKED'); ?>::<?php echo JText::_('TIME_UNIT_COUNTS_INFO'); ?>"><h3><?php echo JText::_('UNIT_COUNTS_BOOKED'); ?></h3></th>
								<th valign="top" class="hasTip" title="<?php echo JText::_('UNIT_DISCOUNT'); ?>::<?php echo JText::_('TIME_UNIT_DISCOUNT_INFO'); ?>"><h3><?php echo JText::_('UNIT_DISCOUNT'); ?></h3></th>
							<?php } ?>
							<th valign="top" class="show_occupancy hasTip" title="<?php echo JText::_('ADULT_OCCUPANCY'); ?>::<?php echo JText::_('ADULT_OCCUPANCY_INFO'); ?>"><h3><?php echo JText::_('ADULT'); ?></h3></th>
							<th valign="top" class="show_occupancy hasTip" title="<?php echo JText::_('CHILD_OCCUPANCY'); ?>::<?php echo JText::_('ADULT_OCCUPANCY_INFO'); ?>"><h3><?php echo JText::_('CHILD'); ?></h3></th>
							<th valign="top"><h3><?php echo JText::_('FROM'); ?><span class="star"> *</span></h3></th>
							<th valign="top"><h3><?php echo JText::_('TO'); ?><span class="star"> *</span></h3></th>
						</tr>
					</thead>
					<tbody id="tprices">
						<?php 
							$pcount = count($this->prices);					
							for ($i = 0; $i < $pcount; $i++) {
								$price = &$this->prices[$i];
								TablePrice::display($price);
								/* @var $price TablePrice */
								JFilterOutput::objectHTMLSafe($price);
								$id = $i ? $price->id : '';
							?>
							<tr <?php if (! $id) { ?>id="price1" style="display: none"<?php } ?> class="row<?php echo $i % 2; ?>">
								<td class="check" rowspan="2">
									<input type="checkbox" class="inputCheckbox" name="pcid[]" value="1"/>
								</td>
								<td class="id" rowspan="2">
									<?php echo $price->id ? $price->id : '<i>' . JText::_('NEW') . '</i>'; ?>
								</td>
								<?php if ($config->usingPrices) { ?>
								<td rowspan="2" class="basic-price">
									<label class="inline"> 
										<input type="text" name="<?php echo PRICES_PREFIX; ?>value[<?php echo $id; ?>]" value="<?php echo $price->value; ?>" class="number" onkeyup="ACommon.toFloat(this)" />
										<div><?php echo $config->mainCurrency;?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>price_capacity_multiply[<?php echo $id; ?>]" value="<?php echo $price->price_capacity_multiply; ?>" />
									<label class="inline hasTip" title="<?php echo JText::_('MULTIPLY_CAPACITY'); ?>::<?php echo JText::_('PRICE_MULTIPLY_CAPACITY_INFO'); ?>">
										<input type="checkbox" class="inputCheckbox" id="<?php echo 'price_capacity_multiply' . $id; ?>" name="another_fake[]" <?php if ($price->price_capacity_multiply) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" /> 			
										<div class="checkboxLabel"><?php echo JText::_('MULTIPLY_CAPACITY'); ?></div>
									</label>
								</td>
								<?php } 
								if ($config->usingPrices == PRICES_WITH_DEPOSIT) { ?>
								<td rowspan="2">
									
									<input type="text" name="<?php echo PRICES_PREFIX; ?>deposit[<?php echo $id; ?>]" value="<?php echo $price->deposit; ?>" class="number" onkeyup="ACommon.toFloat(this)" id="deposit<?php echo $id; ?>" />
									<?php echo JHTML::_('select.genericlist', $deposittype, PRICES_PREFIX . 'deposit_type[' . $id . ']', '', 'value', 'text', $price->deposit_type); ?>
								</td>
								<td rowspan="2">
									<?php echo JHTML::_('select.genericlist', $canceltimesettings, PRICES_PREFIX . 'expiration_setting[' . $id . ']', 'onchange="EditSubject.setPaymentExpirationType(this)"', 'value', 'text', BookingHelper::typeOfCancelTime($price->cancel_time)); ?>
									<br />
									<input type="text" name="<?php echo PRICES_PREFIX; ?>cancel_time[<?php echo $id; ?>]" value="<?php echo BookingHelper::formatFromCancelTime($price->cancel_time); ?>" class="number" onkeyup="ACommon.toFloat(this)"/>
									<?php echo JHTML::_('select.genericlist', $canceltime, PRICES_PREFIX . 'expiration_format[' . $id . ']', '', 'value', 'text', BookingHelper::formatOfCancelTime($price->cancel_time)); ?>
								</td>
								<td rowspan="2" class="deposit-settings">
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>deposit_multiply[<?php echo $id; ?>]" value="<?php echo $price->deposit_multiply; ?>" />
									<label class="inline hasTip" title="<?php echo JText::_('DEPOSIT_MULTIPLY'); ?>::<?php echo JText::_('DEPOSIT_MULTIPLY_INFO'); ?>">
										<input type="checkbox" class="inputCheckbox" name="another_fake[]" <?php if ($price->deposit_multiply) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxLabel"><?php echo JText::_('DEPOSIT_MULTIPLY'); ?></div>
									</label>
									<div class="clr"></div>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>deposit_capacity_multiply[<?php echo $id; ?>]" value="<?php echo $price->deposit_capacity_multiply; ?>" />
									<label class="inline hasTip" title="<?php echo JText::_('MULTIPLY_CAPACITY'); ?>::<?php echo JText::_('DEPOSIT_MULTIPLY_CAPACITY_INFO'); ?>">
										<input type="checkbox" class="inputCheckbox" id="<?php echo 'deposit_capacity_multiply' . $id; ?>" name="another_fake[]" <?php if ($price->deposit_capacity_multiply) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" /> 			
										<div class="checkboxLabel"><?php echo JText::_('MULTIPLY_CAPACITY'); ?></div>
									</label>
									<div class="clr"></div>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>deposit_include_supplements[<?php echo $id; ?>]" value="<?php echo $price->deposit_include_supplements; ?>" />
									<label class="inline hasTip" title="<?php echo JText::_('INCLUDE_SUPPLEMENTS'); ?>::<?php echo JText::_('INCLUDE_SUPPLEMENTS_INFO'); ?>">
										<input type="checkbox" class="inputCheckbox" id="<?php echo 'deposit_include_supplements' . $id; ?>" name="another_fake[]" <?php if ($price->deposit_include_supplements) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" /> 			
										<div class="checkboxLabel"><?php echo JText::_('INCLUDE_SUPPLEMENTS'); ?></div>
									</label>
								</td>
								<?php }
								if ($config->usingPrices) { ?>
									<td rowspan="2">
										<textarea class="price" rows="1" cols="1" name="<?php echo PRICES_PREFIX; ?>unit_count[<?php echo $id; ?>]"><?php echo $price->unit_count; ?></textarea>
									</td>
									<td rowspan="2">
										<textarea class="price" rows="1" cols="1" name="<?php echo PRICES_PREFIX; ?>unit_discount[<?php echo $id; ?>]"><?php echo $price->unit_discount; ?></textarea>
									</td>
								<?php } ?>
								<td class="show_occupancy" style="width: 150px;" rowspan="2">
								<?php //$template = JURI::base().'templates/'.JFactory::getTemplate();?>
								<div class='<?php echo PRICES_PREFIX; ?>adult_occupancy_price'>
									<?php 
									$maxId = 0;
									if($price->adult_occupancy_price)
									foreach($price->adult_occupancy_price as $key=>$occupancyPrice){
										$maxId = ($maxId < $key)? $key : $maxId;
										?>
									<div style="clear:both;"><span>
										<input type="text" style="width: 20%; display: inline" class="price hasTip" title="Occupancy" name="<?php echo PRICES_PREFIX; ?>adult_occupancy_price[<?php echo $id; ?>][<?php echo $key; ?>][occupancy]" value="<?php echo $occupancyPrice['occupancy']; ?>" />
										</span><span>
										<input type="text" style="width: 40%; display: inline" class="price hasTip" title="Price Modifier (decrease price)" name="<?php echo PRICES_PREFIX; ?>adult_occupancy_price[<?php echo $id; ?>][<?php echo $key; ?>][price]" value="<?php echo $occupancyPrice['price']; ?>" />
										</span><span>
										<a class="aIcon aIconUnpublish" onclick="EditSubject.deleteItem(this);" style="width: 40%; display: inline"> </a>
										</span>
										</div>
									<?php }?>
									</div>
									<script>
										EditSubject.occupancy_id = <?php echo $maxId+1; ?>;
									</script>
									<a onclick="EditSubject.addItem(this,'<?php echo PRICES_PREFIX; ?>adult_occupancy_price', <?php echo $id? $id : "''"; ?>,'Remove', '<?php echo $template; ?>/images/menu/icon-16-delete.png');" class="add-icon aIcon aIconNew" style="clear: both; display: block;"> </a>
									
								</td>
								<td class="show_occupancy" style="width: 150px;" rowspan="2">
								<div class='<?php echo PRICES_PREFIX; ?>child_occupancy_price'>
									<?php 
									$maxId = 0;
									if($price->child_occupancy_price)
									foreach($price->child_occupancy_price as $key=>$occupancyPrice){
										$maxId = ($maxId < $key)? $key : $maxId;
										?>
									<div style="clear:both;"><span>
										<input type="text" style="width: 20%; display: inline" class="price hasTip" title="Occupancy" name="<?php echo PRICES_PREFIX; ?>child_occupancy_price[<?php echo $id; ?>][<?php echo $key; ?>][occupancy]" value="<?php echo $occupancyPrice['occupancy']; ?>" />
										</span><span>
										<input type="text" style="width: 40%; display: inline" class="price hasTip" title="Price Modifier (increase price)" name="<?php echo PRICES_PREFIX; ?>child_occupancy_price[<?php echo $id; ?>][<?php echo $key; ?>][price]" value="<?php echo $occupancyPrice['price']; ?>" />
										</span><span>
										<a class="aIcon aIconUnpublish" onclick="EditSubject.deleteItem(this);" style="width: 40%; display: inline"> </a>
										</span>
										</div>
									<?php }?>
									</div>
									<script>
										EditSubject.occupancy_id = <?php echo $maxId+1; ?>;
									</script>
									<a onclick="EditSubject.addItem(this,'<?php echo PRICES_PREFIX; ?>child_occupancy_price', <?php echo $id? $id : "''"; ?>,'Remove', '<?php echo $template; ?>/images/menu/icon-16-delete.png');" class="add-icon aIcon aIconNew" style="clear: both; display: block;"> </a>
									
								</td>
								<td class="select" rowspan="2">
									<?php echo AHtml::getFilterSelect(PRICES_PREFIX . 'rezervation_type[' . $id . ']', 'select', $rtypes, $price->rezervation_type, false, 'onchange="EditSubject.setPriceReservationType(this)"', 'id', 'fullTitle'); ?>
									<label>
										<div><?php echo JText::_('WEEK_AVAILABILITY'); ?></div>
										<?php echo JHTML::_('select.genericlist', $weeks, PRICES_PREFIX . 'week[' . $id . ']', '', 'value', 'text', $price->week); ?>
									</label>
									<label title="<?php echo JText::_('COLOR_OF_PRICE_FIELD_IN_CALENDAR'); ?>">
										<div><?php echo JText::_('COLOR_IN_CALENDAR'); ?></div>
										<input type="text" name="<?php echo PRICES_PREFIX; ?>custom_color[<?php echo $id; ?>]" value="<?php echo $price->custom_color; ?>" class="color {pickerPosition:'top',required:false}" size="7" />
									</label>
								</td>	
								<td class="date">
									<div>
										<?php if ($i)
											echo AHtml::getCalendar($price->date_up, PRICES_PREFIX . 'date_up[' . $id . ']', 'priceDateUp' . $price->id, ADATE_FORMAT_NORMAL, ADATE_FORMAT_NORMAL_CAL, '', false, 0); ?>
										<div class="clr"></div>
									</div>
									<div style="padding: 10px 0px 0px 0px">
										<?php if ($i)
											echo AHtml::getTimePicker($price->time_up, PRICES_PREFIX . 'time_up[' . $id . ']', false, '', true); ?>
										<div class="clr"></div>
									</div>
								</td>
								<td class="date">
									<div>
										<?php if ($i)
											echo AHtml::getCalendar($price->date_down, PRICES_PREFIX . 'date_down[' . $id . ']', 'priceDateDown' . $price->id, ADATE_FORMAT_NORMAL, ADATE_FORMAT_NORMAL_CAL, '', false, 0); ?>
										<div class="clr"></div>
									</div>
									<div style="padding: 10px 0px 0px 0px">
										<?php if ($i)
											echo AHtml::getTimePicker($price->time_down, PRICES_PREFIX . 'time_down[' . $id . ']', false, '', true); ?>
										<div class="clr"></div>
									</div>
								</td>								
							</tr>
							<tr <?php if (! $id) { ?>id="price2" style="display: none"<?php } ?> class="row<?php echo $i % 2; ?>">
								<td colspan="2">
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>over_midnight[<?php echo $id; ?>]" value="<?php echo $price->over_midnight; ?>" />
									<label class="inline hasTip" title="<?php echo JText::_('OVER_MIDNIGHT'); ?>::<?php echo JText::_('OVER_MIDNIGHT_INFO'); ?>">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->over_midnight) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxLabel"><?php echo JText::_('OVER_MIDNIGHT'); ?></div>
									</label>
									<div class="clr" style="padding: 5px"></div>
									<h3 style="float: left; margin: 0px; padding: 1px 10px 0px 0px;"><?php echo JText::_('DAYS_AVAILABILITY'); ?>:</h3>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>monday[<?php echo $id; ?>]" value="<?php echo $price->monday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->monday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('MON'); ?></div>
									</label> 
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>tuesday[<?php echo $id; ?>]" value="<?php echo $price->tuesday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->tuesday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Tue'); ?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>wednesday[<?php echo $id; ?>]" value="<?php echo $price->wednesday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->wednesday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Wed'); ?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>thursday[<?php echo $id; ?>]" value="<?php echo $price->thursday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->thursday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Thu'); ?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>friday[<?php echo $id; ?>]" value="<?php echo $price->friday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->friday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Fri'); ?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>saturday[<?php echo $id; ?>]" value="<?php echo $price->saturday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->saturday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Sat'); ?></div>
									</label>
									<input type="hidden" name="<?php echo PRICES_PREFIX; ?>sunday[<?php echo $id; ?>]" value="<?php echo $price->sunday; ?>" />
									<label class="inline">
										<input type="checkbox" class="inputCheckbox" name="fake[]" <?php if ($price->sunday) { ?>checked="checked"<?php } ?> onchange="ACommon.check(this);" />
										<div class="checkboxDayLabel"><?php echo JText::_('Sun'); ?></div>
									</label>
								</td>		
							</tr>
						<?php } ?>
						<tr id="price-empty" <?php if ($pcount > 1) { ?>style="display: none;"<?php } ?>><td colspan="16" class="emptyList"><?php echo JText::_('EMPTY_PRICES_LIST'); ?></td></tr>
					</tbody>
				</table>
				<div class="clr"></div>
			</div>
		<?php } else { ?>
			<p class="emptyParentList"><?php echo JText::_('ADD_RESERVATION_TYPES_AND_APPLY'); ?></p>
		<?php } ?>
    </fieldset>
</div>

<script>
window.addEvent('domready', function(){ //make sure dom elements are loaded first
    $$('select[name^=price-expiration_setting]').each(function(item){EditSubject.setPaymentExpirationType(item);});
});
</script>