/**
 * Javascript for configuration form
 * 
 * @version $Id$
 * @package ARTIO Booking
 * @subpackage assets
 * @copyright Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author ARTIO s.r.o., http://www.artio.net
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link http://www.artio.net Official website
 */

var ViewConfig = {

	/**
	 * Valid form before submit. Standard in Joomla! administration.
	 * 
	 * @param pressbutton
	 *            button selected in toolbar
	 */
	submitbutton : function(pressbutton) {
		switch (pressbutton) {
		case 'apply':
			// save last select bookmark into cookies
			ACommon.saveBookmark();
			break;
		}
		submitform(pressbutton);
	},

	/**
	 * Some options have child options. This child options are selectable only
	 * if masters options are switch on. This function disable child options if
	 * masters are switch off. This function set events for masters - if masters
	 * go to switch on then child options are enabled.
	 * 
	 * @param boolean
	 *            setEvents if true then function set events for masters - run
	 *            only once during initialise
	 */
	setEvents : function(setEvents) {

  	// show names (mine/all)
  	this.setDisabled('params_display_mine_only0', 'params_display_who_reserve0');
  	this.setDisabled('params_display_mine_only1', 'params_display_who_reserve0');

		// bookmark main
		this.setDisabled('params_date_long', 'params_date_type0');
		this.setDisabled('params_date_normal', 'params_date_type0');
		this.setDisabled('params_date_day', 'params_date_type0');
		this.setDisabled('params_date_day_short', 'params_date_type0');
		this.setDisabled('params_time', 'params_date_type0');

		/* bookmark objects */

		// thumbnails
		this.setDisabled('params_display_thumbs_subjects_list_width',
				'params_display_thumbs_subjects_list0');
		this.setDisabled('params_display_thumbs_subjects_list_height',
				'params_display_thumbs_subjects_list0');

		// introtext
		this.setDisabled('params_display_readmore_subjects_list_length',
				'params_display_readmore_subjects_list0');

		// pagination
		if ($('params_subjects_pagination0').checked || $('params_subjects_pagination1').checked) {
			$('params_subjects_pagination_start').setProperty('disabled', false);
			$('params_subjects_pagination_selector0').setProperty('disabled', false);
			$('params_subjects_pagination_selector1').setProperty('disabled', false);
		}
		if ($('params_subjects_pagination2').checked) {
			$('params_subjects_pagination_start').setProperty('disabled', true);
			$('params_subjects_pagination_selector0').setProperty('disabled', true);
			$('params_subjects_pagination_selector1').setProperty('disabled', true);
		}

		// monthly calendars
		this.setDisabled('params_subjects_calendar_skin',
				'params_subjects_calendar0');
		this.setDisabled('params_subjects_calendar_start',
				'params_subjects_calendar0');
		this.setDisabled('params_subjects_calendar_deep',
				'params_subjects_calendar0');
		// weekly calendars
		this.setDisabled('params_subjects_week_deep', 'params_subjects_week0');

		/* bookmark object */

		// main image
		this.setDisabled('params_display_thumbs_subject_detail_width',
				'params_display_image_subject_detail0');
		this.setDisabled('params_display_thumbs_subject_detail_height',
				'params_display_image_subject_detail0');
		// images gallery
		this.setDisabled('params_display_gallery_subject_position',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_display_gallery_subject_style',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_gallery_slideshow_duration',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_gallery_slideshow_shift',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_display_gallery_thumbs_subject_detail_width',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_display_gallery_thumbs_subject_detail_height',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_display_gallery_preview_subject_detail_width',
				'params_display_gallery_subject_detail0');
		this.setDisabled('params_display_gallery_preview_subject_detail_height',
				'params_display_gallery_subject_detail0');

		/* gallery slideshow options */
		if ($('params_display_gallery_subject_detail1').checked)
			$('params_gallery_slideshow_duration').setProperty('disabled', $('params_display_gallery_subject_style').value != 'slideshow');
		if ($('params_display_gallery_subject_detail1').checked)
			$('params_gallery_slideshow_shift').setProperty('disabled', $('params_display_gallery_subject_style').value != 'slideshow');

		/* bookmark prices */
		if ($('params_thousand_separator0').checked)
			$('params_thousand_separator_char').setProperty('disabled', true);
		if ($('params_thousand_separator1').checked)
			$('params_thousand_separator_char').setProperty('disabled', true);
		if ($('params_thousand_separator2').checked)
			$('params_thousand_separator_char').setProperty('disabled', true);
		if ($('params_thousand_separator3').checked)
			$('params_thousand_separator_char').setProperty('disabled', true);
		if ($('params_thousand_separator4').checked)
			$('params_thousand_separator_char').setProperty('disabled', false);
		
		$('params_main_currency').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_last_zero0').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_last_zero1').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_decimals').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_decimals_point0').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_decimals_point1').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator0').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator1').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator2').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator3').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator4').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_thousand_separator_char').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_price_format').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_online_payment_expiration_time').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_b2b_tax0').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_b2b_tax1').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_total_price0').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_total_price1').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_payment_status').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_unit_price').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_deposit_price').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_price_excluding_tax').setProperty('disabled', $('params_using_prices').value == '0');
		$('params_show_tax').setProperty('disabled', $('params_using_prices').value == '0');
		
		$('params_show_deposit_price').setProperty('disabled', $('params_using_prices').value != '2');

		$('params_redirection_after_reservation_menu_item').setProperty('disabled', $('params_redirection_after_reservation').value != '5');
		$('params_redirection_after_reservation_custom_url').setProperty('disabled', $('params_redirection_after_reservation').value != '6');
		
		// set events for all masters
		if (setEvents) {

			Array.each($('adminForm').getElements('*[class^=masterChild]'),
					function(child, index) {
						child.getParent().getParent().addClass('masterChild');
						child.removeClass('masterChild');
					});

			var masters = new Array('params_display_who_reserve0', 'params_display_who_reserve1',
					'params_date_type0', 'params_date_type1',
					'params_quick_navigator0', 'params_quick_navigator1',
					'params_subjects_pagination0', 'params_subjects_pagination1', 'params_subjects_pagination2',
					'params_display_thumbs_subjects_list0',
					'params_display_thumbs_subjects_list1',
					'params_display_image_subject_detail0',
					'params_display_image_subject_detail1',
					'params_display_gallery_subject_detail0',
					'params_display_gallery_subject_detail1',
					'params_thousand_separator0',
					'params_thousand_separator1', 
					'params_thousand_separator2',
					'params_thousand_separator3',
					'params_thousand_separator4',
					'params_subjects_calendar0',
					'params_subjects_calendar1', 'params_subjects_week0',
					'params_subjects_week1',
					'params_display_readmore_subjects_list0',
					'params_display_readmore_subjects_list1',
					'params_using_prices',
					'params_display_gallery_subject_style',
					'params_redirection_after_reservation');
			for ( var i = 0; i < masters.length; i++)
			{
				try{
					$(masters[i]).addEvent('click', function() {
						ViewConfig.setEvents(false);
					});
				}catch(e){console.error( masters[i], " id probably don't exists");}
			}
		}
	},

	/**
	 * Disable child option if master is switch off.
	 * 
	 * @param string
	 *            child ID of child option
	 * @param string
	 *            master ID of master option
	 */
	setDisabled : function(child, master) {
		$(child).setProperty('disabled', $(master).checked);
	}
}

try {
	/**
	 * Joomla! 1.6.x
	 */
	Joomla.submitbutton = function(pressbutton) {
		return ViewConfig.submitbutton(pressbutton);
	}
} catch (e) {
	/**
	 * Joomla! 1.5.x
	 */
	function submitbutton(pressbutton) {
		return ViewConfig.submitbutton(pressbutton);
	}
}