<?php

/**
 * Reservation edit form template.
 * 
 * @version		$Id$
 * @package		ARTIO Booking
 * @subpackage  views
 * @copyright	Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author 		ARTIO s.r.o., http://www.artio.net
 * @license     GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link        http://www.artio.net Official website
 */

defined('_JEXEC') or die('Restricted access');

/* @var $this BookingViewReservation */

$config = AFactory::getConfig();

?>
<div class="edit item-page">
<form action="index.php" method="post" name="adminForm" id="adminForm">
	<h1><?php echo JText::_('RESERVATION')?></h1>
	<div class="bookingToolbar">
		<a class="aIconToolSave tool save" title="<?php echo JText::_('JSave', true); ?>" href="javascript:submitbutton('save')"><?php echo JText::_('JSave', true); ?></a>
		<a class="aIconToolApply tool apply" title="<?php echo JText::_('JApply', true); ?>" href="javascript:submitbutton('apply')"><?php echo JText::_('JApply', true); ?></a>
		<a class="aIconToolCancel tool cancel" title="<?php echo JText::_('JCancel', true); ?>" href="<?php echo JRoute::_(ARoute::view(VIEW_RESERVATIONS)); ?>"><?php echo JText::_('JCancel', true); ?></a>
		<div class="clr"></div>
	</div>
		<fieldset>
    		<legend><?php echo JText::_('CUSTOMER'); ?></legend>
    		<div class="formelm">	
    			<label><?php echo JText::_('CUSTOMER'); ?>:</label>
    			<?php echo JElementCustomer::fetchElement($this->reservation->customer); ?>
			</div>    			
    		<div class="formelm">
    			<label for="title_before"><?php echo JText::_('TITLE_BEFORE'); ?>: </label>
    			<input type="text" name="title_before" id="title_before" maxlength="255" value="<?php echo $this->reservation->title_before; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="firstname"><?php echo JText::_('FIRST_NAME'); ?>: </label>
    			<input type="text" name="firstname" id="firstname" maxlength="255" value="<?php echo $this->reservation->firstname; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="middlename"><?php echo JText::_('MIDDLE_NAME'); ?>: </label>
    			<input type="text" name="middlename" id="middlename" maxlength="255" value="<?php echo $this->reservation->middlename; ?>" />
    		</div>	
    		<div class="formelm">
    			<label for="surname"><?php echo JText::_('SURNAME'); ?>: </label>
    			<input type="text" name="surname" id="surname" maxlength="255" value="<?php echo $this->reservation->surname; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="title_after"><?php echo JText::_('TITLE_AFTER'); ?>: </label>
    			<input type="text" name="title_after" id="title_after" maxlength="255" value="<?php echo $this->reservation->title_after; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="company"><?php echo JText::_('COMPANY'); ?>: </label>
    			<input type="text" name="company" id="company" maxlength="255" value="<?php echo $this->reservation->company; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="company_id"><?php echo JText::_('COMPANY_ID'); ?>: </label>
    			<input type="text" name="company_id" id="company_id" maxlength="255" value="<?php echo $this->reservation->company_id; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="vat_id"><?php echo JText::_('VAT_ID'); ?>: </label>
    			<input type="text" name="vat_id" id="vat_id" maxlength="255" value="<?php echo $this->reservation->vat_id; ?>" />
    		</div>
    		<?php if (is_array($config->rsExtra)) { foreach ($config->rsExtra as $field) { ?>
	    		<div class="formelm">
			    	<label for="<?php echo $field['name']; ?>"><?php echo $field['title']; ?>: </label>
			    	<input type="text" name="<?php echo $field['name']; ?>" id="<?php echo $field['name']; ?>" size="60" maxlength="255" value="<?php echo AUtils::getArrayValue($this->reservation->fields, $field['name'] . '.value'); ?>" />
			 	</div>
			<?php } } ?>
    	</fieldset>
    <?php     	
    	$z=0;
		$countReservedItems = count($this->reservedItems);
    	if ($countReservedItems)
    		foreach ($this->reservedItems as $reservedItem){
				$id = $z++;
				$subject = $this->subjects[$reservedItem->subject];

	?>
    	<fieldset id="reservationItem<?php echo $reservedItem->id; ?>">
    		<legend><?php if ($countReservedItems>1) echo '#'.$z.' '?><?php echo JText::_('RESERVATION'); ?></legend>
    		
    		<input type="hidden" name="id[<?php echo $id?>]" value="<?php echo $reservedItem->id?>">
    		<input type="hidden" name="subject[<?php echo $id?>]" value="<?php echo $reservedItem->subject?>">
    		<input type="hidden" name="subject_title[<?php echo $id?>]" value="<?php echo $reservedItem->subject_title?>">
    		<input type="hidden" name="rtype[<?php echo $id?>]" value="<?php echo $reservedItem->rtype?>">
    		<?php if (!empty($reservedItem->boxIds)) { ?>
    			<?php foreach ($reservedItem->boxIds as $bid) { ?>
					<input type="hidden" name="boxIds[<?php echo $id?>][]" value="<?php echo $bid; ?>" />
				<?php } ?>
			<?php } else { ?>
				<input type="hidden" name="boxIds[<?php echo $id?>][]" value="" />
			<?php } ?>
    		
    		<div class="formelm">
    			<label></label>
   				<a class="aIconLegend aIconUnpublish" href="javascript:removeReservationItem(<?php echo $reservedItem->id; ?>, <?php echo $this->reservation->id; ?>)" title=""><?php echo JText::_('REMOVE_ITEM'); ?></a>
   			</div>
	    	<div class="formelm">
	    		<label for="subject_title[<?php echo $id?>]"><?php echo JText::_('SUBJECT'); ?>: </label>
    			<input type="text" name="subject_title[<?php echo $id?>]" id="subject_title[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->subject_title; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="capacity[<?php echo $id?>]"><?php echo JText::_('CAPACITY'); ?>: </label></td>
    			<input type="text" name="capacity[<?php echo $id?>]" id="capacity[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->capacity; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="from[<?php echo $id?>]"><?php echo JText::_('FROM'); ?>: </label>
    			<div style="display: inline-block;">
    				<?php echo AHtml::getCalendar($reservedItem->from, 'from['.$id.']','from['.$id.']', ADATE_FORMAT_LONG, ADATE_FORMAT_LONG_CAL,'',true,false); ?>
    			</div>
    		</div>
    		<div class="formelm">
    			<label for="to[<?php echo $id?>]"><?php echo JText::_('TO'); ?>: </label>
    			<div style="display: inline-block;">
    				<?php echo AHtml::getCalendar($reservedItem->to, 'to['.$id.']', 'to['.$id.']', ADATE_FORMAT_LONG, ADATE_FORMAT_LONG_CAL,'',true,false); ?>
    			</div>
    		</div>
    		<div class="formelm">
    			<label for="price"><?php echo ITEM_PRICE_TIP ?>: </label>
    			<input type="text" name="price[<?php echo $id?>]" id="price[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->price; ?>" />
    		</div>
    		<div class="formelm">	
    			<label for="fullPrice"><?php echo FULL_PRICE_TIP ?>: </label>
    			<input type="text" name="fullPrice[<?php echo $id?>]" id="fullPrice[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->fullPrice; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="fullPriceSupplements"><?php echo FULL_PRICE_SUPPLEMENTS_TIP ?>: </label>
    			<input type="text" name="fullPriceSupplements[<?php echo $id?>]" id="fullPriceSupplements[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->fullPriceSupplements; ?>" />
    		</div>
    		<div class="formelm">	
    			<label for="deposit"><?php echo ITEM_DEPOSIT_TIP ?>: </label>
    			<input type="text" name="deposit[<?php echo $id?>]" id="deposit[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->deposit; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="fullDeposit"><?php echo FULL_DEPOSIT_TIP ?>: </label>
    			<input type="text" name="fullDeposit[<?php echo $id?>]" id="fullDeposit[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->fullDeposit; ?>" />
    		</div>
    		<div class="formelm">	
    			<label for="tax"><?php echo JText::_('TAX'); ?>: </label>
    			<input type="text" name="tax[<?php echo $id?>]" id="tax[<?php echo $id?>]" maxlength="255" value="<?php echo $reservedItem->tax; ?>" />
    		</div>
    		<?php 
    			foreach ($reservedItem->supplementsRaw as $supplement) {
    				$value = $capacity = null;
					foreach ($reservedItem->supplements as $item) {
						$toCompare = $this->reservation->id ? $item->supplement : $item->id;
						if ($toCompare == $supplement->id) {
							$value = $item->value;
							$capacity = $item->capacity;
							break;
						}
					}
				?>
					<div class="formelm">
						<label><?php echo $supplement->title; ?>: </label>
    					<?php echo BookingHelper::displaySupplementInput($supplement, $value, $capacity, $id); ?>
    				</div>  	
    		<?php } ?>		
    	</fieldset>
    <?php } ?>
    	<fieldset>
    		<legend><?php echo JText::_('PAYMENT'); ?></legend>
    		<div class="formelm">
    			<label for="fax"><?php echo JText::_('IS_RECEIVE'); ?>: </label>
    			<select name="paid" id="paid">
    				<option value="<?php echo RESERVATION_RECEIVE; ?>" <?php if ($this->reservation->paid == RESERVATION_RECEIVE) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('JYES'); ?></option>
    				<option value="<?php echo RESERVATION_RECEIVE_DEPOSIT; ?>" <?php if ($this->reservation->paid == RESERVATION_RECEIVE_DEPOSIT) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('DEPOSIT'); ?></option>
    				<option value="<?php echo RESERVATION_PENDING; ?>" <?php if ($this->reservation->paid == RESERVATION_PENDING) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('JNO'); ?></option>
    			</select>
			</div>
			<div class="formelm">    	
				<label for="fax"><?php echo JText::_('JSTATUS'); ?>: </label>
				<select name="state" id="state">
					<option value="<?php echo RESERVATION_PRERESERVED; ?>" <?php if ($this->reservation->state == RESERVATION_PRERESERVED) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('PRE_RESERVED'); ?></option>
    				<option value="<?php echo RESERVATION_ACTIVE; ?>" <?php if ($this->reservation->state == RESERVATION_ACTIVE) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('RESERVED'); ?></option>
    				<option value="<?php echo RESERVATION_STORNED; ?>" <?php if ($this->reservation->state == RESERVATION_STORNED) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('CANCELLED'); ?></option>
    				<option value="<?php echo RESERVATION_TRASHED; ?>" <?php if ($this->reservation->state == RESERVATION_TRASHED) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('TRASHED'); ?></option>
    				<option value="<?php echo RESERVATION_CONFLICTED; ?>" <?php if ($this->reservation->state == RESERVATION_TRASHED) { ?>selected="selected"<?php } ?>>
    					<?php echo JText::_('CONFLICTED'); ?></option>
    			</select>
			</div>
    		    	</fieldset>
    	<fieldset>
    		<legend><?php echo JText::_('CONTACT'); ?></legend>
    		<div class="formelm">
    			<label for="street"><?php echo JText::_('STREET'); ?>: </label>
    			<input type="text" name="street" id="street" maxlength="255" value="<?php echo $this->reservation->street; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="city"><?php echo JText::_('CITY'); ?>: </label>
    			<input type="text" name="city" id="city" maxlength="255" value="<?php echo $this->reservation->city; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="zip"><?php echo JText::_('ZIP'); ?>: </label>
    			<input type="text" name="zip" id="zip" maxlength="255" value="<?php echo $this->reservation->zip; ?>" />
    		</div>
    		<div class="formelm">
   				<label for="country"><?php echo JText::_('COUNTRY'); ?>: </label>
    			<input type="text" name="country" id="country" maxlength="255" value="<?php echo $this->reservation->country; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="email"><?php echo JText::_('EMAIL'); ?>: </label>
    			<input type="text" name="email" id="email" maxlength="255" value="<?php echo $this->reservation->email; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="telephone"><?php echo JText::_('TELEPHONE'); ?>: </label>
    			<input type="text" name="telephone" id="telephone" maxlength="255" value="<?php echo $this->reservation->telephone; ?>" />
    		</div>
    		<div class="formelm">
    			<label for="fax"><?php echo JText::_('FAX'); ?>: </label>
    			<input type="text" name="fax" id="fax" maxlength="255" value="<?php echo $this->reservation->fax; ?>" />
    		</div>
    		<div class="formelm">
		    	<label for="note"><?php echo JText::_('NOTE'); ?></label>
		    	<textarea name="note" id="note" cols="50" rows="10"><?php echo $this->reservation->note; ?></textarea>
		    </div>
    	</fieldset>
	<div class="bookingToolbar">
		<a class="aIconToolSave tool save" title="<?php echo JText::_('JSave', true); ?>" href="javascript:submitbutton('save')"><?php echo JText::_('JSave', true); ?></a>
		<a class="aIconToolApply tool apply" title="<?php echo JText::_('JApply', true); ?>" href="javascript:submitbutton('apply')"><?php echo JText::_('JApply', true); ?></a>
		<a class="aIconToolCancel tool cancel" title="<?php echo JText::_('JCancel', true); ?>" href="<?php echo JRoute::_(ARoute::view(VIEW_RESERVATIONS)); ?>"><?php echo JText::_('JCancel', true); ?></a>
		<div class="clr"></div>
	</div>
	<input type="hidden" name="option" value="<?php echo OPTION; ?>" />
	<input type="hidden" name="controller" value="<?php echo CONTROLLER_RESERVATION; ?>" />
	<input type="hidden" name="boxchecked" value="1" />
	<input type="hidden" name="Itemid" value="<?php echo JRequest::getInt('Itemid'); ?>" />
	<input type="hidden" name="cid[]" value="<?php echo $this->reservation->id; ?>" />
	<input type="hidden" name="task" value="" />
	<?php echo JHTML::_('form.token'); ?>
</form>
</div>