<?php
/**
 * Reservations list template.
 * 
 * @version		$Id$
 * @package		ARTIO Booking
 * @subpackage  views
 * @copyright	Copyright (C) 2010 ARTIO s.r.o.. All rights reserved.
 * @author 		ARTIO s.r.o., http://www.artio.net
 * @license     GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @link        http://www.artio.net Official website
 */

defined('_JEXEC') or die('Restricted access');

$config = AFactory::getConfig();

/* @var $this BookingViewReservations */

?>
<h1><?php echo JText::_('RESERVATION_LIST'); ?></h1>
<form action="<?php echo JRoute::_(ARoute::viewlayout(VIEW_RESERVATIONS, 'customer')); ?>" method="post" name="adminForm" id="adminForm" class="registration">
	<div class="filter">
		<div class="filterItem">
		<label for="filter_items-subject_title" id="filter_subject_label"><?php echo JText::_('ITEM'); ?>: </label>
			<input type="text" name="filter_items-subject_title" id="filter_items-subject_title" size="15" class="inputbox" onchange="this.form.submit();" value="<?php echo $this->escape($this->lists['items-subject_title']); ?>"/>
			<label for="filter_from" id="filter_from_label"><?php echo JText::_('FROM'); ?>: </label>
			<?php echo AHtml::getCalendar($this->lists['from'], 'filter_from', 'filter_from', ADATE_FORMAT_MYSQL_DATE, ADATE_FORMAT_MYSQL_DATE_CAL); ?>
			<label for="filter_to" id="filter_to_label"><?php echo JText::_('TO'); ?>: </label>
			<?php echo AHtml::getCalendar($this->lists['to'], 'filter_to', 'filter_to', ADATE_FORMAT_MYSQL_DATE, ADATE_FORMAT_MYSQL_DATE_CAL); ?>
		</div>
		<div class="filterItem">
			<?php 
				$options = array();
				$options[] = JHtml::_('select.option', '', '- ' . JText::_('RESERVATION_STATUS') . ' -');
				$options[] = JHtml::_('select.option', RESERVATION_ACTIVE, JText::_('RESERVED'));
				$options[] = JHtml::_('select.option', RESERVATION_STORNED, JText::_('CANCELLED'));
				echo JHtml::_('select.genericlist', $options, 'filter_reservation_status', 'onchange="this.form.submit()"', 'value', 'text', $this->lists['reservation_status']);
				if ($config->showPaymentStatus) {
					$options = array();
					$options[] = JHtml::_('select.option', '', '- ' . JText::_('PAYMENT_STATUS') . ' -');
					$options[] = JHtml::_('select.option', RESERVATION_PENDING, JText::_('UNPAID'));
					$options[] = JHtml::_('select.option', RESERVATION_RECEIVE_DEPOSIT, JText::_('DEPOSIT_PAID'));
					$options[] = JHtml::_('select.option', RESERVATION_RECEIVE, JText::_('PAID_IN_FULL'));
					echo JHtml::_('select.genericlist', $options, 'filter_payment_status', 'onchange="this.form.submit()" class="inputbox"', 'value', 'text', $this->lists['payment_status']);
				}
			?>
		</div>
		<div class="buttons">
			<input class="button btn btn-primary" type="submit" onclick="this.form.submit();" value="<?php echo $this->escape(JText::_('GO')); ?>" />
			<input class="button btn btn-primary" type="submit" onclick="this.form.reset.value=1; this.form.submit();" value="<?php echo $this->escape(JText::_('RESET')); ?>" />
		</div>
		<div class="clr"></div>
	</div>
	<table class="category table table-striped table-bordered table-hover">
		<thead>
			<tr>
				<th nowrap="nowrap"><?php echo JText::_('RES_NUM'); ?></th>
				<th nowrap="nowrap">
				    <?php echo JHTML::_('grid.sort', 'Item', 'items-subject_title', $this->lists['order_Dir'], $this->lists['order']); ?>
				</th>
				<th nowrap="nowrap">
				    <?php echo JHTML::_('grid.sort', 'Cap.', 'items-capacity', $this->lists['order_Dir'], $this->lists['order']); ?>
				</th>
				<th colspan="2" nowrap="nowrap">
				    <?php echo JHTML::_('grid.sort', 'From', 'from', $this->lists['order_Dir'], $this->lists['order']); ?>
					<br/>
				    <?php echo JHTML::_('grid.sort', 'To', 'to', $this->lists['order_Dir'], $this->lists['order']); ?>
				</th>
				<?php if ($config->showTotalPrice || $config->showDepositPrice) { ?>
					<th nowrap="nowrap">
						<?php if ($config->showTotalPrice) {
				    		echo JHTML::_('grid.sort', 'Price', 'reservationFullPrice', $this->lists['order_Dir'], $this->lists['order']); ?>
				    		<?php if ($config->showDepositPrice) { ?>
								<br/>
							<?php }
							} ?>
						<?php if ($config->showDepositPrice) {
				    		echo JHTML::_('grid.sort', 'Deposit', 'reservationFullDeposit', $this->lists['order_Dir'], $this->lists['order']);
				    	} ?>
					</th>
				<?php } ?>
				<th nowrap="nowrap">
					<?php if ($config->showPaymentStatus) { ?>
				    	<?php echo JHTML::_('grid.sort', 'Payment Status', 'paid', $this->lists['order_Dir'], $this->lists['order']); ?>
						<br/>
					<?php } ?>
				    <?php echo JHTML::_('grid.sort', 'Reservation Status', 'state', $this->lists['order_Dir'], $this->lists['order']); ?>
				</th>
				<th nowrap="nowrap">
					<?php echo JText::_('JCancel'); ?>
				</th>
			</tr>
		</thead>
		<tbody>
			<?php if (! is_array($this->items) || ! count($this->items)) { ?>
				<tr><td colspan="9"><?php echo JText::_('NO_ITEMS_FOUND'); ?></td></tr>
			<?php 
				} else {
					foreach ($this->items as $i => $reservation) {
						/* @var $item TableReservation */
						foreach ($this->reservedItems[$reservation->id] as $j => $reservedItem) {
			?>
				    <tr class="row<?php echo $i % 2; ?> cat-list-row<?php echo $i % 2; ?>">
				    	<?php if ($j==0){ ?>
				    	<td rowspan="<?php echo count($this->reservedItems[$reservation->id]); ?>" align="center">
				    		<a href="<?php echo JRoute::_(ARoute::view(VIEW_RESERVATION, null, null, array('cid' => $reservation->id))); ?>" title="<?php echo $this->escape(JText::_('DISPLAY_RESERVATION_DETAIL')); ?>"><?php echo $reservation->id; ?></a>
				    	</td>
				    	<?php } ?>
				    	<?php if (!$reservedItem) { ?>
				    		<td colspan="4">No subject reserved</td>
				    	<?php } else { ?>
				    	<td>
				    		<?php if (! is_null($reservedItem->subjectId)) { ?>
				    			<a href="<?php echo JRoute::_(ARoute::view(VIEW_SUBJECT, $reservedItem->subject, $reservedItem->subjectAlias)); ?>" title="<?php echo $this->escape(sprintf($this->escape(JText::_('DISPLAY_OBJECT_S')), $reservedItem->subject_title)); ?>"><?php echo $reservedItem->subject_title; ?></a>
				    		<?php } else { ?>
				    			<span title="<?php echo $this->escape(JText::_('SUBJECT_NOT_FOUND')); ?>"><?php echo $reservedItem->subject_title; ?></span>
				    		<?php } ?>
				    	</td>
				    	<td>
				    		<span class="badge badge-info"><?php echo $reservedItem->capacity; ?></span>
				    	</td>
				    	<?php if ($reservedItem->rtype == RESERVATION_TYPE_PERIOD) { ?>
				    		<td colspan="2"><?php echo JText::_('PERIODIC_RESERVATION'); ?></td>
				    	<?php } else { ?>
				    		<td>
				    			<?php echo AHtml::date($reservedItem->from, ADATE_FORMAT_NORMAL, 0); ?>
				    			<br/><br/>
				    			<?php echo AHtml::date($reservedItem->to, ADATE_FORMAT_NORMAL, 0); ?>
				    		</td>
				    		<td>
				    			<?php echo AHtml::date($reservedItem->from, ATIME_FORMAT_SHORT, 0); ?>
				    			<br/><br/>
				    			<?php echo AHtml::date($reservedItem->to, ATIME_FORMAT_SHORT, 0); ?>
				    		</td>
				    	<?php } ?>
				    	<?php } ?>
				    	<?php if ($j == 0) { 
				    		if ($config->showTotalPrice || $config->showDepositPrice) { ?>
				    		<td rowspan="<?php echo count($this->reservedItems[$reservation->id]); ?>">
				    			<?php if ($config->showTotalPrice) { ?>
				    				<span class="badge badge-info"><?php echo BookingHelper::displayPrice($reservation->reservationFullPrice); ?></span>
				    				<?php if ($config->showDepositPrice) { ?>
				    					<br/><br/>
				    				<?php } 
				    				} ?>
				    			<?php if ($config->showDepositPrice) { ?>
				    				<span class="badge badge-info hasTip" title="<?php echo $this->escape(JText::_('EXPIRATION'))?>::<?php echo $this->escape($this->depositExpires[$reservation->id]); ?>"><?php echo BookingHelper::displayPrice($reservation->reservationFullDeposit); ?></span>
				    			<?php } ?>
				    		</td>
				    	<?php } ?>
				    	<td rowspan="<?php echo count($this->reservedItems[$reservation->id]); ?>">
				    		<?php if ($config->showPaymentStatus) { ?>
				    			<?php echo AHtml::renderReservationPaymentStateIcon($reservation); ?>
					    		<br/><br/>
					    	<?php } ?>
				    		<?php echo AHtml::renderReservationStateIcon($reservation); ?>
				    	</td>
				    	<td rowspan="<?php echo count($this->reservedItems[$reservation->id]); ?>">
				    		 <?php if (!$reservation->isExpired && $reservation->state == RESERVATION_ACTIVE) { ?> 
				    			<a title="<?php echo JText::_('CANCEL_RESERVATION'); ?>" class="aIcon aIconUnpublish" href="<?php echo JRoute::_('index.php?option=com_booking&controller=reservation&task=storno&cid[]=' . $reservation->id); ?>"/>
				    		<?php } ?>
				    	</td>
				    	<?php } ?>
				    </tr>
				    <?php } ?>
				<?php } ?>
			<?php } ?>
		</tbody>
	</table>
	<?php if ($this->customerHomepage) { ?>
		<a href="<?php echo $this->customerHomepage; ?>"><?php echo JText::_('BACK'); ?></a>
	<?php } ?>
	<div class="reservations-legend">
			<span class="aIconLegend aIconTick"><?php echo $this->escape(JText::_('RESERVED')); ?><span class="aIconSeparator">&nbsp;</span></span>
			<span class="aIconLegend aIconUnpublish"><?php echo $this->escape(JText::_('CANCELLED')); ?><span class="aIconSeparator">&nbsp;</span></span>
			<span class="aIconLegend aIconExpired"><?php echo $this->escape(JText::_('EXPIRED')); ?></span>
	</div>
	<?php if ($config->showPaymentStatus) { ?>
		<div class="reservations-legend">
			<span class="aIconLegend aIconExpired"><?php echo $this->escape(JText::_('UNPAID')); ?><span class="aIconSeparator">&nbsp;</span></span>
			<span class="aIconLegend aIconPending"><?php echo $this->escape(JText::_('DEPOSIT_PAID')); ?><span class="aIconSeparator">&nbsp;</span></span>
			<span class="aIconLegend aIconPublished"><?php echo $this->escape(JText::_('PAID_IN_FULL')); ?><span>&nbsp;</span></span>
		</div>
	<?php } ?>
    <?php if ($this->pagination->total > $this->pagination->minLimit) { ?>
   		<div class="pagination"><?php echo $this->pagination->getListFooter(); ?></div> 
    <?php } ?>
	<input type="hidden" name="task" value=""/>
	<input type="hidden" name="reset" value="0"/>
	<input type="hidden" name="controller" value="<?php echo CONTROLLER_RESERVATION; ?>"/>
	<input type="hidden" name="boxchecked" value="0"/>
	<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>"/>
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->lists['order_Dir']; ?>"/>
	<input type="hidden" name="<?php echo SESSION_TESTER; ?>" value="1"/>
	<?php echo JHTML::_( 'form.token' ); ?>
</form>	